package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.shop.service.CouponService;
import com.gxwebsoft.shop.entity.Coupon;
import com.gxwebsoft.shop.param.CouponParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 优惠券记录表控制器
 *
 * @author 科技小王子
 * @since 2022-11-28 18:26:05
 */
@Api(tags = "优惠券记录表管理")
@RestController
@RequestMapping("/api/shop/coupon")
public class CouponController extends BaseController {
    @Resource
    private CouponService couponService;

    @PreAuthorize("hasAuthority('shop:coupon:list')")
    @OperationLog
    @ApiOperation("分页查询优惠券记录表")
    @GetMapping("/page")
    public ApiResult<PageResult<Coupon>> page(CouponParam param) {
        PageParam<Coupon, CouponParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(couponService.page(page, page.getWrapper()));
        // 使用关联查询
        //return success(couponService.pageRel(param));
    }

    @PreAuthorize("hasAuthority('shop:coupon:list')")
    @OperationLog
    @ApiOperation("查询全部优惠券记录表")
    @GetMapping()
    public ApiResult<List<Coupon>> list(CouponParam param) {
        PageParam<Coupon, CouponParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(couponService.list(page.getOrderWrapper()));
        // 使用关联查询
        //return success(couponService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:coupon:list')")
    @OperationLog
    @ApiOperation("根据id查询优惠券记录表")
    @GetMapping("/{id}")
    public ApiResult<Coupon> get(@PathVariable("id") Integer id) {
        return success(couponService.getById(id));
        // 使用关联查询
        //return success(couponService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('shop:coupon:save')")
    @OperationLog
    @ApiOperation("添加优惠券记录表")
    @PostMapping()
    public ApiResult<?> save(@RequestBody Coupon coupon) {
        // 记录当前登录用户id、租户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
          coupon.setUserId(loginUser.getUserId());
        }
        if (couponService.save(coupon)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('shop:coupon:update')")
    @OperationLog
    @ApiOperation("修改优惠券记录表")
    @PutMapping()
    public ApiResult<?> update(@RequestBody Coupon coupon) {
        if (couponService.updateById(coupon)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('shop:coupon:remove')")
    @OperationLog
    @ApiOperation("删除优惠券记录表")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (couponService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('shop:coupon:save')")
    @OperationLog
    @ApiOperation("批量添加优惠券记录表")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<Coupon> list) {
        if (couponService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('shop:coupon:update')")
    @OperationLog
    @ApiOperation("批量修改优惠券记录表")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<Coupon> batchParam) {
        if (batchParam.update(couponService, "coupon_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('shop:coupon:remove')")
    @OperationLog
    @ApiOperation("批量删除优惠券记录表")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (couponService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
